//
//  BFRecordScreenBaseManager.swift
//  BFRecordScreenKit
//
//  Created by 胡志强 on 2022/1/13.
//

import Foundation
import GPUImage
import BFCommonKit
import BFMediaKit


class BFRecordScreenBaseManager : NSObject{
    
    weak var dele:BFRecordScreenController?
    
    weak var assetPlayer: AVPlayer?
    weak var recordPlayer : AVPlayer?
    var progreddL : UILabel?
    var progressThumV: BFVideoThumbProgressView?
    
    var recordItem : BFRecordItemModel?{
        didSet{
            recordItem?.fetchPlayItemCallBack = {[weak self] model in
                self?.resetEnv()
            }
        }
    }
    var playView : GPUImageView?
    var filter = GPUImageFilter()
    
    var currentAssetProgress: CMTime = .zero{
        didSet{
            self.dele?.currentAssetProgress = currentAssetProgress
        }
    }

    var recording = false
    // MARK: -
    func resetEnv(){
        dele?.currentAssetProgress = currentAssetProgress
        progreddL?.text = CMTimeGetSeconds(currentAssetProgress).formatDurationToHMS()
    }
    
    func startRecord(){
        if recording{
            return
        }
        
        recording = true
    }

    func endRecord(){
        recording = false
    }
    
    func play(){
        
    }
    
    func pause(){
        
    }
    
    func changeRecordMaterail(){
        
    }
    
    func deleteRecord(at: CMTime) {
        
    }
    
    func cancelRecord(){
        
        
    }
    
    func dragEnd(){
        
    }
    
    func clean(){
        DispatchQueue.global().async {
            GPUImageContext.sharedFramebufferCache().purgeAllUnassignedFramebuffers()
        }
    }
    
    deinit {
        clean()
        BFLog(1, message: "\(self) release")
    }
}
