//
//  BFVideoCoverViewCell.swift
//  BFRecordScreenKit
//
//  Created by SanW on 2021/12/15.
//  Copyright © 2021 BytesFlow. All rights reserved.
//

import UIKit
import GPUImage
import BFCommonKit

open class BFVideoCoverViewCell: BFImageCoverViewCell {

    @objc public class func gpuVideoViewCell(collectionView: UICollectionView, indexPath: IndexPath) -> BFVideoCoverViewCell {
        let cell: BFVideoCoverViewCell = collectionView.dequeueReusableCell(withReuseIdentifier: String(describing: BFVideoCoverViewCell.self), for: indexPath) as! BFVideoCoverViewCell
        return cell
    }
    
    public override func addData() {
        super.addData()
        
        //add by ak 如果是视频素材取到视频数据后在进行扶正操作。
        if(recordItem?.mediaType == .Video){
            
            recordItem?.fetchAVUrlAssetCallBack = {[weak self] in
            DispatchQueue.main.async {[weak self] in
            guard let wself = self else { return }
                    wself.rotationView()
                }
            }
        }
       
   
    }
    
    public func rotationView(){
        if let asset = recordItem?.videoAsset {
            let degress = degressFromVideoFile(asset: asset)
//            BFLog(1, message: "degress:\(degress)")
            switch degress {
            case 90:
                playView.setInputRotation(GPUImageRotationMode(rawValue: 2), at: 0)
            case 180:
                playView.setInputRotation(GPUImageRotationMode(rawValue: 7), at: 0)
            case 270:
                playView.setInputRotation(GPUImageRotationMode(rawValue: 1), at: 0)
            default:
                playView.setInputRotation(GPUImageRotationMode(rawValue: 0), at: 0)
                break
            }
        }
    }

}
